\documentclass{article}
\usepackage{hyperref}
\usepackage[linguistics]{forest}
\usepackage{graphicx}
\usepackage[margin=1in]{geometry}
\usepackage{adjustbox}
\usepackage{bookmark}
\usepackage{rotating}
\usepackage{amsmath}
\usepackage{tikz}
\usepackage{mwe}
\usepackage{amsbsy}


\title{Programming Assignment \#2: Expectation Maximization}
\author{John Karasev}
\date{May 30, 2018}

\def\kmean{./figures/kmeans/k0.png,./figures/kmeans/k2.png,./figures/kmeans/k7.png}
\def\bkmean{./figures/kmeans_best/k2.png,./figures/kmeans_best/k3.png,./figures/kmeans_best/k4.png, ./figures/kmeans_best/k5.png}
\def\gmm{./figures/gmm/g0.png,./figures/gmm/g3.png,./figures/gmm/g20.png}
\def\bgmm{./figures/gmm_best/K2.pdf,./figures/gmm_best/K3.pdf,./figures/gmm_best/K4.pdf,./figures/gmm_best/K5.pdf}

\begin{document}
\maketitle


\section*{Summary}
This experiment resulted in clustering a 2d dataset that was created from
two Gaussian distributions with overlaps. See the figure below to see the dataset.
First the data was clustered using k-means with different k values. In the second
part it was clustered using a GMM EM. The dataset can be found here \url{<https://gitlab.com/PSU_P/cs446/cs446_p2/blob/master/GMM_dataset.txt>}
\vspace{1cm}

\adjustbox{valign=t}{\includegraphics[width=15cm]{./figures/dataset}}

\pagebreak

\section{Kmeans}
Kmeans clustering was applied to the dataset for $K=1,2,3,4,5$. The initial means where initialized to
random datapoints. For each $K$, the
algorithm was performed 10 times to get the most optimal clustering that reduces the error.
The first sequence of diagrams show different iterations for $k=2$ and the second show optimal
clustering for each of the $K$ values. See appendix for $\mu$ values for each $K$.

\newdimen\X
\begin{tikzpicture}[overlay,
	picture/.style={draw,rectangle,anchor=#1,inner sep=0pt,outer sep=0pt}
   ]
   \X=0mm
   \foreach \Image in \kmean {
     \node[picture=north west] at (\X,-10.5mm)
	   {\includegraphics[width=49.5mm,height=35mm]{\Image}};
     \global\advance\X by 49.5mm
   }
\end{tikzpicture}

\newdimen\X
\begin{tikzpicture}[overlay,
	picture/.style={draw,rectangle,anchor=#1,inner sep=0pt,outer sep=0pt}
   ]
   \X=0mm
   \foreach \Image in \bkmean {
     \node[picture=north west] at (\X,-50.5mm)
	   {\includegraphics[width=40mm,height=35mm]{\Image}};
     \global\advance\X by 40mm
   }
\end{tikzpicture}
\vspace {10cm}

\noindent
The more clusters where added to the kmeans algorithm, the more the error decreased.
Note the error used for Kmeans is
\[J = \sum_{n=1}^{N} \sum_{k=1}^{K} r_{nk} ||\textbf{x}_{n} - \mu_{k}|| \]
where $r_{nk} \in \{0,1\}$ indicates what datum belongs to which cluster.
Below is a chart that shows the error for different $K$ values.
\vspace{1cm}

{
\centering
\adjustbox{valign=t}{\includegraphics[width=10cm]{./figures/kmerror.pdf}}\par
}

\pagebreak

\section{Gaussian Mixture Models Expectation Maximization}
Same as kmeans, for each $K$ the algorithm was performed many times to find the most
optimal clustering. Training time was much longer than K-means. To initialize the initial parameters,
kmeans was performed first to find intitial means, covariance was set to within cluster variance, and
the mix coefficients were set to the percentage of datapoints in each cluster. The first sequence of diagrams show different
iterations for $k=3$ and the second show optimal clustering for each of the $K$ values. The algorithm was experimented on
$K=2,3,4,5$. See appendix for parameters of each GMM for each $K$.

\newdimen\X
\begin{tikzpicture}[overlay,
	picture/.style={draw,rectangle,anchor=#1,inner sep=0pt,outer sep=0pt}
   ]
   \X=0mm
   \foreach \Image in \gmm {
     \node[picture=north west] at (\X,-10.5mm)
	   {\includegraphics[width=49.5mm,height=35mm]{\Image}};
     \global\advance\X by 49.5mm
   }
\end{tikzpicture}

\newdimen\X
\begin{tikzpicture}[overlay,
	picture/.style={draw,rectangle,anchor=#1,inner sep=0pt,outer sep=0pt}
   ]
   \X=0mm
   \foreach \Image in \bgmm {
     \node[picture=north west] at (\X,-50.5mm)
	   {\includegraphics[width=40mm,height=35mm]{\Image}};
     \global\advance\X by 40mm
   }
\end{tikzpicture}

\vspace {10cm}

\noindent
For $k < 3$ the log-likelihood was very low, but for $k >=3$ the log likelihoods where close
to each other. The log-likelihood formula used is
\[\ln p(\textbf{X}|\pmb{\mu}, \pmb{\Sigma}, \pmb{\pi}) = \sum_{n=1}^{N}\ln\Big\{ \sum_{k=1}^{K}\pi_{k}\mathcal{N}(\pmb{x}_{n}|\pmb{\mu}_{k},\pmb{\Sigma}_{k})\Big\}\]
{
\centering
\adjustbox{valign=t}{\includegraphics[width=10cm]{./figures/log.pdf}}\par
}
\pagebreak

\section*{Appendix}

\subsection*{K-Means}


\begin{enumerate}
	\item[$k=2$]
		\[\mu_{1} =\ <-0.5177, 0.0218>\]
		\[\mu_{2} =\ <1.69081, 0.0884>\]
		\[error = 1586.160755\]
	\item[$k=3$]
		\[\mu_{1} =\ <1.75,0.051>\]
		\[\mu_{2} =\ <-1.0362,-1.15076>\]
		\[\mu_{3} =\ <-0.2845, 0.4042>\]
		\[error = 1425.342343\]
	\item[$k=4$]
		\[\mu_{1} =\ <1.87505863,0.15439879>\]
		\[\mu_{2} =\ <-1.22543163,1.26682594>\]
		\[\mu_{3} =\ <-1.15496244,-1.19945329>\]
		\[\mu_{4} =\ <0.19617507,-0.07648302>\]
		\[error = 1222.277878\]
	\item[$k=5$]
		\[\mu_{1} =\ <1.96958296,0.12718118>\]
		\[\mu_{2} =\ <1.66153738,-1.20779844>\]
		\[\mu_{3} =\ <-1.23309412,0.19996993>\]
		\[\mu_{4} =\ <0.07621522,-0.07583429>\]
		\[\mu_{5} =\ <1.70294339,1.41824316>\]
		\[error = 1046.156943\]
\end{enumerate}
\subsection*{GMM}
\begin{enumerate}
	\item[$k=2$]
		\[\pmb{\mu}_{1} =\ \begin{bmatrix}1.94053109 & 0.17011146 \end{bmatrix}\]
		\[ \pmb{\Sigma}_{1} =
		\begin{bmatrix}
			0.12087717 & -0.01152791 \\
			-0.01152791 & 1.40119894
		\end{bmatrix} \]
		\[\pi_{1} = 0.35479675\]
		\[\pmb{\mu}_{2} =\ \begin{bmatrix}-0.11509533 & -0.0068307\end{bmatrix}\]
		\[ \pmb{\Sigma}_{2} =
		\begin{bmatrix}
			0.9666211 & -0.09555901 \\
			-0.09555901 & 0.87905493
		\end{bmatrix} \]
		\[\pi_{2} = 0.64522228\]
		\[loglikelihood = -4449.89\]
	\item[$k=3$]
	\[\pmb{\mu}_{1} =\ \begin{bmatrix}-0.09277952 & 0.11511638 \end{bmatrix}\]
	\[ \pmb{\Sigma}_{1} =
	\begin{bmatrix}
		1.05560119 & -0.9873249 \\
		-0.9873249 &  1.03607075
	\end{bmatrix} \]
	\[\pi_{1} = 0.33818288\]
	\[\pmb{\mu}_{2} =\ \begin{bmatrix}1.9639934 &  0.09246893\end{bmatrix}\]
	\[ \pmb{\Sigma}_{2} =
	\begin{bmatrix}
		0.10279217  & -0.0109  \\
		-0.0109    &  1.09699946
	\end{bmatrix} \]
	\[\pi_{2} = 0.32798721\]
	\[\pmb{\mu}_{3} =\ \begin{bmatrix} 0.00426297 & -0.03965128\end{bmatrix}\]
	\[ \pmb{\Sigma}_{3} =
	\begin{bmatrix}
		1.05519928 & 0.9999203  \\
		 0.9999203  & 1.06856408
	\end{bmatrix} \]
	\[\pi_{3} =  0.33383639\]
	\[loglikelihood = -3927.356\]
	\item[$k=4$]
	\[\pmb{\mu}_{1} =\ \begin{bmatrix}-0.00261296 & -0.04154601 \end{bmatrix}\]
	\[ \pmb{\Sigma}_{1} =
	\begin{bmatrix}
		 1.05243879&  0.99872825 \\
		0.99872825 & 1.06803331
	\end{bmatrix} \]
	\[\pi_{1} = 0.33265334\]
	\[\pmb{\mu}_{2} =\ \begin{bmatrix}-0.84892057 & 0.835103\end{bmatrix}\]
	\[ \pmb{\Sigma}_{2} =
	\begin{bmatrix}
		0.68532774 &-0.64309544 \\
		-0.64309544 & 0.70947265
	\end{bmatrix} \]
	\[\pi_{2} = 0.14317633\]
	\[\pmb{\mu}_{3} =\ \begin{bmatrix}  1.96277513 & 0.06207938\end{bmatrix}\]
	\[ \pmb{\Sigma}_{3} =
	\begin{bmatrix}
		0.10286029& -0.01382704  \\
		-0.01382704 & 1.14735928
	\end{bmatrix} \]
	\[\pi_{3} =  0.33292048\]
	\[\pmb{\mu}_{4} =\ \begin{bmatrix}  0.42525198& -0.37141319\end{bmatrix}\]
	\[ \pmb{\Sigma}_{4} =
	\begin{bmatrix}
		0.5426144 & -0.48990789  \\
		-0.48990789 & 0.5608374
	\end{bmatrix} \]
	\[\pi_{4} =  0.19115255\]
	\[loglikelihood = -3925.736\]
	\item[$k=5$]
	\[\pmb{\mu}_{1} =\ \begin{bmatrix}1.64705991 & 1.24585446 \end{bmatrix}\]
	\[ \pmb{\Sigma}_{1} =
	\begin{bmatrix}
		 0.17829332 & 0.11054871 \\
		0.11054871 & 0.46428922
	\end{bmatrix} \]
	\[\pi_{1} = 0.33265334\]
	\[\pmb{\mu}_{2} =\ \begin{bmatrix}-0.31827742 & 0.31670248\end{bmatrix}\]
	\[ \pmb{\Sigma}_{2} =
	\begin{bmatrix}
		0.93430619 &7-0.89005259 \\
		-0.89005259&  0.95332942
	\end{bmatrix} \]
	\[\pi_{2} = 0.27449654\]
	\[\pmb{\mu}_{3} =\ \begin{bmatrix}  -0.13273759& -0.16147795\end{bmatrix}\]
	\[ \pmb{\Sigma}_{3} =
	\begin{bmatrix}
		0.9133976  & 0.87314322  \\
		0.87314322 & 0.94865452
	\end{bmatrix} \]
	\[\pi_{3} =  0.30724611\]
	\[\pmb{\mu}_{4} =\ \begin{bmatrix}  1.03586492 & -0.80531093\end{bmatrix}\]
	\[ \pmb{\Sigma}_{4} =
	\begin{bmatrix}
		0.40869155& -0.32774536  \\
		-0.32774536 & 0.44659006
	\end{bmatrix} \]
	\[\pi_{4} =  0.0774689\]
	\[loglikelihood = -3925.736\]
	\[\pmb{\mu}_{5} =\ \begin{bmatrix}  2.03632519 & -0.08918787\end{bmatrix}\]
	\[ \pmb{\Sigma}_{5} =
	\begin{bmatrix}
		0.08211353  &0.01880781  \\
		 0.01880781 & 0.88834066
	\end{bmatrix} \]
	\[\pi_{5} =  0.2599479\]
	\[loglikelihood = -3924.01911\]
\end{enumerate}







\end{document}
